<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_RequiredFieldValue ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_RequiredFieldValue extends AbstractStructArrayBase
{
    /**
     * The Value
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_RequiredFieldValue[]
     */
    public $Value;
    /**
     * Constructor method for ArrayOfJP_RequiredFieldValue
     * @uses ArrayOfJP_RequiredFieldValue::setValue()
     * @param \StructType\JP_RequiredFieldValue[] $value
     */
    public function __construct(array $value = array())
    {
        $this
            ->setValue($value);
    }
    /**
     * Get Value value
     * @return \StructType\JP_RequiredFieldValue[]|null
     */
    public function getValue()
    {
        return $this->Value;
    }
    /**
     * Set Value value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RequiredFieldValue[] $value
     * @return \ArrayType\ArrayOfJP_RequiredFieldValue
     */
    public function setValue(array $value = array())
    {
        foreach ($value as $arrayOfJP_RequiredFieldValueValueItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_RequiredFieldValueValueItem instanceof \StructType\JP_RequiredFieldValue) {
                throw new \InvalidArgumentException(sprintf('The Value property can only contain items of \StructType\JP_RequiredFieldValue, "%s" given', is_object($arrayOfJP_RequiredFieldValueValueItem) ? get_class($arrayOfJP_RequiredFieldValueValueItem) : gettype($arrayOfJP_RequiredFieldValueValueItem)), __LINE__);
            }
        }
        $this->Value = $value;
        return $this;
    }
    /**
     * Add item to Value value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_RequiredFieldValue $item
     * @return \ArrayType\ArrayOfJP_RequiredFieldValue
     */
    public function addToValue(\StructType\JP_RequiredFieldValue $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_RequiredFieldValue) {
            throw new \InvalidArgumentException(sprintf('The Value property can only contain items of \StructType\JP_RequiredFieldValue, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Value[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_RequiredFieldValue|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_RequiredFieldValue|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_RequiredFieldValue|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_RequiredFieldValue|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_RequiredFieldValue|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Value
     */
    public function getAttributeName()
    {
        return 'Value';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_RequiredFieldValue
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
